class MapPlugin extends Plugin {
  init() {
    const editor = this.editor;

    editor.ui.componentFactory.add('mapButton', locale => {
      const view = new ButtonView(locale);

      view.set({
        label: 'Insert Map',
        icon: mapIcon,
        tooltip: true,
      });

      view.on('execute', () => {
        fetch('/si-maps/ckeditor/ajax')
          .then(response => response.json())
          .then(data => {
            const mapId = prompt('Enter the map ID:, ', Object.keys(data).join(', '));
            if (mapId) {
              editor.model.change(writer => {
                const mapElement = writer.createElement('map', {
                  id: mapId,
                });

                editor.model.insertContent(mapElement);
              });
            }
          });
      });

      return view;
    });
  }
}

ClassicEditor
.create(document.querySelector('#editor'), {
  plugins: [MapPlugin],
  toolbar: ['mapButton'],
})
  .catch(error => {
    console.error(error);
  });
