<?php

declare(strict_types=1);

namespace Drupal\simple_interactive_maps;

use Drupal\Core\Config\Entity\ConfigEntityInterface;

/**
 * Provides an interface defining an interactive map entity type.
 */
interface InteractiveMapInterface extends ConfigEntityInterface {

  /**
   * Gets the embed code for the interactive map.
   *
   * @return string
   *   The embed code.
   */
  public function getEmbedCode(): string;

  /**
   * Recursively compare two copies of the region data.
   *
   * @param array $regions
   *   The regions data to compare with.
   *
   * @return bool
   *   Returns true if there are no differences between the regions and the data.
   */
  public function compareRegionsData(array $regions): bool;

}
